function useVModel(props, key, emit, options = {}) {
  var _a, _b, _c, _d, _e
  const {
    clone = false,
    passive = false,
    eventName,
    deep = false,
    defaultValue,
    shouldEmit
  } = options
  const vm = getCurrentInstance()
  const _emit =
    emit ||
    (vm == null ? void 0 : vm.emit) ||
    ((_a = vm == null ? void 0 : vm.$emit) == null ? void 0 : _a.bind(vm)) ||
    ((_c = (_b = vm == null ? void 0 : vm.proxy) == null ? void 0 : _b.$emit) == null
      ? void 0
      : _c.bind(vm == null ? void 0 : vm.proxy))
  let event = eventName
  if (!key) {
    if (isVue2) {
      const modelOptions =
        (_e = (_d = vm == null ? void 0 : vm.proxy) == null ? void 0 : _d.$options) == null
          ? void 0
          : _e.model
      key = (modelOptions == null ? void 0 : modelOptions.value) || 'value'
      if (!eventName) event = (modelOptions == null ? void 0 : modelOptions.event) || 'input'
    } else {
      key = 'modelValue'
    }
  }
  event = event || `update:${key.toString()}`
  const cloneFn = (val) =>
    !clone ? val : typeof clone === 'function' ? clone(val) : cloneFnJSON(val)
  const getValue = () => (isDef(props[key]) ? cloneFn(props[key]) : defaultValue)
  const triggerEmit = (value) => {
    if (shouldEmit) {
      if (shouldEmit(value)) _emit(event, value)
    } else {
      _emit(event, value)
    }
  }
  if (passive) {
    const initialValue = getValue()
    const proxy = ref(initialValue)
    let isUpdating = false
    watch(
      () => props[key],
      (v) => {
        if (!isUpdating) {
          isUpdating = true
          proxy.value = cloneFn(v)
          nextTick(() => (isUpdating = false))
        }
      }
    )
    watch(
      proxy,
      (v) => {
        if (!isUpdating && (v !== props[key] || deep)) triggerEmit(v)
      },
      { deep }
    )
    return proxy
  } else {
    return computed({
      get() {
        return getValue()
      },
      set(value) {
        triggerEmit(value)
      }
    })
  }
}
